#ifndef WALLWINDOW_H
#define WALLWINDOW_H

#include <QDialog>
#include <QSystemTrayIcon>
#include <QDir>
#include <QToolButton>
#include <QSettings>
#include <QtGui>
#include <QApplication>
#include <QFileDialog>
#include <QtDebug>
#include <QFile>
#include <QTextStream>
#include <QProcess>
#include <QSystemTrayIcon>
#include <QMenu>
#include <QAction>
#include <QTimer>

QT_BEGIN_NAMESPACE
class QGroupBox;
class QLabel;
class QPushButton;
class QCheckBox;
class QComboBox;
class QTableWidget;
class QSpinBox;
QT_END_NAMESPACE

class Button : public QToolButton
{
    Q_OBJECT

public:
    Button(const QString &text, QWidget *parent = 0);
};

class WallWindow : public QDialog
{
    Q_OBJECT

public:
    WallWindow();
    QFileInfoList load_and_show ();

private:
    QFileInfoList allFiles;
    QFileInfo now;
    QStringList added_files;
    QList<int> rand_numbers, linear_list;
    QList<int> create_randlist();

    QGroupBox *mainGroupBox;
    QLabel *countlabel;
    QLabel *imgpos_label;
    QLabel *scroll_label;
    QLabel *time_label;
    QLabel *img_order_label;
    QTableWidget *tableWidget;
    QSpinBox *timeBox;
    QComboBox *pos_comboBox;
    QComboBox *order_comboBox;
    QCheckBox *onlynames_checkBox;
    QPushButton *startButton;
    QPushButton *closeButton;
    QPushButton *clearButton;
    QPushButton *addButton;

    Button *createButton(const QString &text, const char *member, int &num);
    //enum { NumDigitButtons = 1000 };
    //Button *removeButtons[NumDigitButtons];
    QList<Button *> removeButtons;
    QList<QLabel *> removeLabel;
    QLabel *label;
    QTimer* switchTimer;
    QSystemTrayIcon* trayIcon;
    QSettings *settings;
    QIcon *trayicon, *delicon;

private slots:
    int set_image();
    void start_clicked();
    void quitButton_clicked();
    void iconActivated(QSystemTrayIcon::ActivationReason reason);
    void config_save();
    void tableFill();
    void processStart(QString path, QString arg);
    void on_onlynames_checkBox_stateChanged(int );
    void on_timeBox_valueChanged(int );
    void add_clicked();
    void digitClicked();
    void on_tableWidget_cellDoubleClicked(int row, int column);
    void on_tableWidget_cellClicked(int row, int column);
    void clear_clicked();
    void on_pos_comboBox_currentIndexChanged(QString name);
    void order_comboBox_currentIndexChanged(QString name);
    void createLayout();

protected:
    void closeEvent(QCloseEvent *event);
};

#endif // WALLWINDOW_H
